# Übungsaufgabe: Algebraische Optimierung
Gesucht sind Vor- und Nachname all derer Eigentümer, die eine Immobilie besitzen, die sowohl von einer auf Malerei speizialisierten Handwerksfirma als Firmensitz verwendet wird, als auch frühestens im Jahre 17975 erbaut wurde.

## a) {-}
\begin{center}
\begin{tikzpicture}[every path/.style={thick, auto, node distance=2cm}]
\node (eigentuemer) at (0, 0) {Eigentümer};
\node (immobilie) at (4, 0) {Immobilie};
\node (handwerksfirma) at (8, 0) {Handwerksfirma};

\node (iid-firmensitz) at (4, 2) {$\sigma_{\text{IID} = \text{Firmensitz}}$};

\node (eid-eigentuemer) at (4, 4) {$\sigma_{\text{EID} = \text{Eigentümer}}$};

\node (baujahr-1975) at (4, 6) {$\sigma_{\text{Baujahr} \geq 1995}$};

\node (fachgebiet-malerarbeit) at (4, 8) {$\sigma_{\text{Fachgebiet} = \text{\flqq Malerarbeit\frqq}}$};

\node (vorname-nachname) at (4, 10) {$\pi_{\text{Vorname, Nachname}}$};

\path[-] (iid-firmensitz) edge (eigentuemer);
\path[-] (iid-firmensitz) edge (immobilie);
\path[-] (iid-firmensitz) edge (handwerksfirma);

\path[-] (eid-eigentuemer) edge (iid-firmensitz);

\path[-] (baujahr-1975) edge (eid-eigentuemer);

\path[-] (fachgebiet-malerarbeit) edge (baujahr-1975);

\path[-] (vorname-nachname) edge (fachgebiet-malerarbeit);
\end{tikzpicture}
\end{center}


## b) {-}
\begin{center}
\begin{tikzpicture}[every path/.style={thick, auto, node distance=2cm}]
\node (eigentuemer) at (0, 2) {Eigentümer};
\node (immobilie) at (4, 0) {Immobilie};
\node (handwerksfirma) at (8, 2) {Handwerksfirma};

\node (baujahr-1975) at (4, 2) {$\sigma_{\text{Baujahr} \geq 1995}$};

\node (eigentuemer-baujahr) at (2, 4) {$\overset{\text{\LARGE$\bowtie$}}{\text{EID} = \text{Eigentümer}}$};

\node (handwerksfirma-malerarbeit) at (8, 4) {$\sigma_{\text{Fachgebiet} = \text{\flqq Malerarbeit \frqq}}$};

\node (eigentuemer-malerarbeit) at (5, 6) {$\overset{\text{\LARGE$\bowtie$}}{\text{IID} = \text{Firmensitz}}$};

\node (vorname-nachname) at (5, 8) {$\pi_{\text{Vorname, Nachname}}$};


\path[-] (baujahr-1975) edge (immobilie);

\path[-] (eigentuemer-baujahr) edge (eigentuemer);
\path[-] (eigentuemer-baujahr) edge (baujahr-1975);

\path[-] (handwerksfirma-malerarbeit) edge (handwerksfirma);

\path[-] (eigentuemer-malerarbeit) edge (handwerksfirma-malerarbeit);
\path[-] (eigentuemer-malerarbeit) edge (eigentuemer-baujahr);

\path (vorname-nachname) edge (eigentuemer-malerarbeit);
\end{tikzpicture}
\end{center}

## Optimierungsgrad \& Heuristiken {-}
### Führe Selektionen so früh wie möglich aus
Die Anfrage in b) veersucht nach jedem JOIN direkt eine Selektion auszuführen um die Anzahl an Zwischenergenissen direkt zu reduzieren
In a) werden hingegen zunächts JOINS ausgeführt und dabei unnötige Abfragen erstellt, die vermieden werden könnten.

### Führe Projektionen so früh wie möglich aus
Sowohl a) als auch b) führen die einzige Projektion so früh wie möglich aus.
Leider kann in diesem Fall die Projektion erst nach allen JOINS ausgeführt werden.

Dies ist wichtig um die Zwischenergebnissen so klein wie möglich zu halten.

### Verknüpfe Folgen von unnären Operatoren
Die Anfrage in a) führt die JOINS zu einem Zeitpunkt aus und kann so mehrere Ergebnisse zusammenfassen.
Da aber alle Ergebnisse voll erweitert werden ist dies kein Vorteil

### Fass einfache Selektionen auf eienr Relation zusammen
In a) werden alle Selektionen nacheinander ausgeführt. Dadurch sind unnötig viele Schritte notwendig obwohl die Information zum wegstreichen von mehreren Reihen zur Verfügung steht.

### Verknüpfe bestimmte Selektionen mit einem vorausgehenden Kartesischen Produkt zu einem Verbund
In a) wird zwar ein kartesisches Produkt gebildet, die Selektionen werden aber nicht im Verbund durchgeführt.
b) hat gar keine Produkte

### Berechne gemeinsame Teilbäume nur einmal
Beide Anfragen verwenden keine Teilbäume doppelt

### Fazit
Die Anfrage in a) sammelt als erstes soviele Daten wie möglich und führt die Selektionen einzeln aus. Dieses Vorgehen belegt viel Speicher und führt zu langsamen Selektionen.
Der einzige Vorteil ist die einfache Generierung und Parallelisierbarkeit der Anfrage.
In b) wird die Ergebniss Menge erst gekürzt und dann erweitert.
Dies führt zu kurzen Selektionsvorgängen und kleinen Datenmengen im Speicher.

Da einige Anfragen aber parallel ausgeführt werden, ist die gesamte Anfrage nur schlecht parallelisierbar.

Insgesammt hat b) einen höhren Optimierungsgrad



